/*
Prove col 12f519
cal: 0c16
*/
extern fastcall void write_EEPROM(unsigned char val, unsigned char address);
extern fastcall unsigned char read_EEPROM(unsigned char address);

extern fastcall void write_Buff (unsigned char index, unsigned char value);
extern fastcall unsigned char read_Buff (unsigned char index);

#include <htc.h>
#include <pic.h>
#include "serial.h"
#include "delay.h"

 
__CONFIG (INTOSC & WDTDIS & MCLRDIS & OSC_8MHZ);

unsigned char address, command;
#define rxIR RB2
#define DLY1 240 //un quarto di bit
#define DLY2 140  //un bit (oltre il ms)

unsigned char rxIRdata (void) {
	unsigned char	c, bitno, datano;

	for(;;) {
		while(rxIR);	
		while(!rxIR);	
        delay_2Us (DLY1);  
//		if(!rxIR)
//			continue;	
        datano = 2;
		bitno = 1;
		do {
           c = 0;
		   do {
              delay_2Us (250); 
              delay_2Us (250); 
              delay_2Us (DLY1); 
              delay_2Us (DLY2); 
              c = (c << 1) | rxIR;

     		} while(--bitno);
           switch (datano) {
              case 0:
                 command = c;
                 return 0;
                 break;
              case 1:
                 address = c;
                 bitno = 6;
                 break;
              case 2:
                 bitno = 5;
                 break;
           }
		} while(datano--);
	}


} 





void main(void) {
unsigned char my_address;
unsigned char c;
TRIS = 0b111000110;

RB5 = 0;
RB4 = 1;
   DelayMs(250);
   DelayMs(250);
   DelayMs(250);

Putch (0x33);
for (;;) {
   rxIRdata();
   Putch(address);
   Putch(command);
   DelayMs(250);
}







RB4 = 1;
DelayMs (250);
RB4 = 0;
RB5 = 1;
DelayMs (250);
RB5 = 0;




   my_address = read_EEPROM(0);
   for (;;) {
     c = getCommand();
     if (!c) {
         switch (read_Buff(2)) {
            case 1:
				RB4 = 1;
				DelayMs (250);
				RB4 = 0;
               break;
            case 7:
				RB5 = 1;
				DelayMs (250);
				RB5 = 0;
               break;
         }
      }
      else if (c==14) {
         if (read_Buff(2)==0) {                      // comando deve essere 0
		    // il pin deve essere in posizione di cambio indirizzo
		    write_EEPROM(read_Buff(3), 0x00);
		 } 
      }
   }
}