; routines di lettura e scrittura eeprom
;
; dichiarare in C come segue:
; extern fastcall void write_EEPROM(unsigned char val, unsigned char address);
; extern fastcall unsigned char read_EEPROM(unsigned char address);

PSECT text,class=CODE,local,delta=2
GLOBAL _write_EEPROM, _read_EEPROM
GLOBAL ?_write_EEPROM
#include <aspic.h>

_write_EEPROM:
bsf 	FSR, 5
movwf 	EEDATA
bcf 	FSR, 5
movf 	?_write_EEPROM, w
bsf 	FSR, 5
movwf 	EEADR
bsf 	WREN
bsf 	WR
bcf 	FSR, 5
retlw	0x00

_read_EEPROM:
bsf 	FSR, 5
movwf 	EEADR
bsf 	RD
movf 	EEDATA, w
bcf 	FSR, 5
movwf 	0xe
retlw	0x00


